# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'panoptic_segmentation.ui'
#
# Created by: PyQt5 UI code generator 5.15.7
#
# WARNING: Any manual changes made to this file will be lost when pyuic5 is
# run again.  Do not edit this file unless you know what you are doing.


from PyQt5 import QtCore, QtGui, QtWidgets
import sys
import pyqtgraph as pg
import warnings
import os
import PIL.Image as Image
import numpy as np
from .own_ImageItem import ImageDraw, ViewBoxNoRightDrag, ContourDraw
import random
from typing import Tuple
from DLIP.gui.backend.label_assistant.panoptic_segmentation.ui_panoptic_seg.gui import io
pg.setConfigOption('imageAxisOrder', 'row-major')

random.seed(108)

# def run(image=None):
#     # Always start by initializing Qt (only once per application)
#     warnings.filterwarnings("ignore")
#     app = QtWidgets.QApplication(sys.argv)
#     os.environ['MXNET_CUDNN_AUTOTUNE_DEFAULT'] = '0'

#     PanopticSegUI(image=image)
#     ret = app.exec_()
#     sys.exit(ret)

class PanopticSegUI(QtWidgets.QMainWindow):
    def __init__(
            self,
            image=None,
            _save_label=None,
            on_label_ui_closed=None,
            ui_shape: Tuple[int, int] = None,
            ui_position: Tuple[int, int] = None,
            parent: QtWidgets.QWidget = None,
            project = None
    ):
        super(PanopticSegUI, self).__init__(parent)
        # MainWindow = QtWidgets.QMainWindow()
        # MainWindow.setObjectName("MainWindow")
        # MainWindow.resize(2057, 1448)
        self.current_class_color = None
        self.class_buttons_list = []
        self.filename = None
        if image is not None:
            self.filename = image
            io._load_image(self, self.filename)
        self.ui_shape = ui_shape
        self.ui_position = ui_position
        self.project = project
        self.hide_masks_checkbox_checked_once = False
        self.show_instances_contours_checkbox_checked_once = False
        self.setGeometry(50, 50, self.ui_shape[0], self.ui_shape[1])
        self.move(self.ui_position[0], self.ui_position[1])
        # self.instance_image = None
        self.colors_list = [(0,0,0)]
        self.on_label_ui_closed = on_label_ui_closed
        self.save_label = _save_label
        self.image = image
        self.image_height = 0
        self.image_width = 0
        self.num_of_classes = self.project["n_classes"]
        self.class_names = self.project["class_names"]
        self.last_point = QtCore.QPoint()
        self.brush_size = 3
        self.is_image_uploaded = False
        self.current_class = None
        self.centralwidget = QtWidgets.QWidget(self)
        self.centralwidget.setObjectName("centralwidget")
        # MainWindow.keyPressEvent = self.keyPressEvent
        self.contour_layer = None
        self.draw_layer = None
        self.image_item = None
        self.PERCENTAGE_FOR_GV = 0.75
        self.PERCENTAGE_FOR_SA = 0.15
        self.graphicsView = pg.GraphicsLayoutWidget(self.centralwidget)
        self.graphicsView.setGeometry(QtCore.QRect(
            ((self.PERCENTAGE_FOR_SA * self.ui_shape[0]) + 100 + 20), 100, self.PERCENTAGE_FOR_GV * self.ui_shape[0], (self.PERCENTAGE_FOR_GV + 0.1) * self.ui_shape[1]))
        self.view_box = ViewBoxNoRightDrag()

        self.view_box.setAspectLocked(True)
        # self.view_box.setBackgroundColor('w')
        # disable menu in view box
        self.view_box.menu = None
        # self.graphicsView.setBackground('g')
        self.graphicsView.setCentralItem(self.view_box)
        # self.draw_layer = ImageDraw(np.zeros((self.image_height, self.image_width, 3)), parent=self, num_of_classes = self.num_of_classes)
        # self.contour_layer = ContourDraw(
        #     np.zeros((self.image_height, self.image_width, 3)), parent=self,)
        self.view_box.invertY(True)
        
        # self.draw_layer.setZValue(1)
        
        

        


        # self.view_box.scene().sigMouseMoved.connect(self.mouse_moved)
        # self.view_box.scene().sigMouseClicked.connect(self.right_mouse_clicked)
        #add a label just above the scroll area
        self.select_class_label = QtWidgets.QLabel(self.centralwidget)
        self.select_class_label.setGeometry(QtCore.QRect(
            20, 450, (self.PERCENTAGE_FOR_SA * self.ui_shape[0]), 30))
        self.select_class_label.setObjectName("select_class_label")
        self.select_class_label.setText("Select a Class")
        self.select_class_label.setAlignment(QtCore.Qt.AlignCenter)

        self.scrollArea = QtWidgets.QScrollArea(self.centralwidget)
        self.scrollArea.setGeometry(QtCore.QRect(
            20, 500, (self.PERCENTAGE_FOR_SA * self.ui_shape[0]), ((self.PERCENTAGE_FOR_GV + 0.1) * self.ui_shape[1]) - 400))
        self.scrollArea.setObjectName("scrollArea")
        self.scrollAreaWidgetContents = QtWidgets.QWidget()
        self.scrollAreaWidgetContents.setObjectName("scrollAreaWidgetContents")
        self.verticalLayout = QtWidgets.QVBoxLayout(
            self.scrollAreaWidgetContents)
        self.verticalLayout.setObjectName("verticalLayout")
        self.scrollArea.setWidget(self.scrollAreaWidgetContents)
        self.scrollAreaWidgetContents.setGeometry(QtCore.QRect(
            0, 0, self.PERCENTAGE_FOR_SA * self.ui_shape[0], ((self.PERCENTAGE_FOR_GV + 0.1) * self.ui_shape[1]) - 400))
        self.scrollArea.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOn)
        self.scrollArea.setHorizontalScrollBarPolicy(
            QtCore.Qt.ScrollBarAlwaysOff)
        self.scrollAreaWidgetContents.setMinimumHeight(
            (50*int(self.num_of_classes)) + 140)
        # self.scrollArea.setFixedHeight(((self.PERCENTAGE_FOR_GV + 1) * self.ui_shape[1]) - 1200)
        #make the background of scroll area black
        # Create as many push buttons as the number of classes

        self.generate_diff_color_palette_push_button = QtWidgets.QPushButton(
            self.scrollAreaWidgetContents)
        
        self.generate_diff_color_palette_push_button.setObjectName(
            "generate_diff_color_palette_push_button")
        self.generate_diff_color_palette_push_button.setText(
            "Generate Different Palette")
        self.generate_diff_color_palette_push_button.clicked.connect(
            self.generate_diff_color_palette)
        temp_i = 0
        for i in range(1,int(self.num_of_classes)):
            tem_i = i
            r = random.randint(0, 255)
            g = random.randint(0, 255)
            b = random.randint(0, 255)
            self.colors_list.append((r,g,b))
            # self.semantic_classes_colors.append((r, g, b))
            self.pushButton = QtWidgets.QPushButton(
                self.scrollAreaWidgetContents)
            self.class_buttons_list.append(self.pushButton)
            self.pushButton.setGeometry(QtCore.QRect(
                ((self.PERCENTAGE_FOR_SA * self.ui_shape[0] - 200) / 2), 70 + 50*i, 200, 30))
            self.pushButton.setObjectName("pushButton" + str(i + 1) + "_" + str(r) + str(g) + str(b))
            # print((self.class_names))
            temp_class_name = self.class_names[i]
            self.pushButton.setText(temp_class_name)
            self.pushButton.clicked.connect(
                self.click_select_class_push_button)
            self.pushButton.setStyleSheet(
                "background-color: rgb(" + str(r) + "," + str(g) + "," + str(b) + ");")

        self.generate_diff_color_palette_push_button.setGeometry(
            QtCore.QRect(((self.PERCENTAGE_FOR_SA * self.ui_shape[0] - 350) / 2), 90 + 50 * (i+1), 350, 27))
        # self.upload_image_push_button = QtWidgets.QPushButton(
        #     self.centralwidget)
        # self.upload_image_push_button.setGeometry(
        #     QtCore.QRect(1090, 1340, 151, 30))
        # self.upload_image_push_button.setObjectName("upload_image_push_button")
        # self.upload_image_push_button.clicked.connect(
        #     self.click_upload_image_push_button)
        

        

        self.hide_masks_checkbox = QtWidgets.QCheckBox(self.centralwidget)
        self.hide_masks_checkbox.setGeometry(QtCore.QRect(20, 200, 120, 27))
        self.hide_masks_checkbox.setObjectName("hide_masks_checkbox")



        self.show_instances_contours_checkbox = QtWidgets.QCheckBox(self.centralwidget)
        self.show_instances_contours_checkbox.setGeometry(QtCore.QRect(20, 170, 300, 27))
        self.show_instances_contours_checkbox.setObjectName("show_instances_contours_checkbox")


        self.brush_size_combo_box = QtWidgets.QComboBox(self.centralwidget)
        self.brush_size_combo_box.setGeometry(
            QtCore.QRect((25 + 180), 250, 70, 27))
        self.brush_size_combo_box.setObjectName("brush_size_combo_box")
        self.brush_size_combo_box.addItem("")
        self.brush_size_combo_box.addItem("")
        self.brush_size_combo_box.addItem("")
        self.brush_size_combo_box.addItem("")
        self.brush_size_combo_box.addItem("")
        self.brush_size_label = QtWidgets.QLabel(self.centralwidget)
        self.brush_size_label.setGeometry(QtCore.QRect(
            20, 250, 180, 21))
        # self.brush_size_label.setAlignment(QtCore.Qt.AlignCenter)
        self.brush_size_label.setObjectName("brush_size_label")
        self.brush_size_combo_box.currentIndexChanged.connect(self.change_brush_size)

        self.opacity_masks_combo_box = QtWidgets.QComboBox(self.centralwidget)
        self.opacity_masks_combo_box.setGeometry(QtCore.QRect((25 + 180), 300, 70, 27))
        self.opacity_masks_combo_box.setObjectName("opacity_masks_combo_box")
        self.opacity_masks_combo_box.addItem("")
        self.opacity_masks_combo_box.addItem("")
        self.opacity_masks_combo_box.addItem("")
        self.opacity_masks_combo_box.addItem("")
        # self.opacity_masks_combo_box.addItem("")
        self.opacity_masks_label = QtWidgets.QLabel(self.centralwidget)
        self.opacity_masks_label.setGeometry(QtCore.QRect(
            20, 300, 180, 21))
        # self.opacity_masks_label.setAlignment(QtCore.Qt.AlignCenter)
        self.opacity_masks_label.setObjectName("opacity_masks_label")
        self.opacity_masks_combo_box.currentIndexChanged.connect(self.change_opacity_masks)

        

        self.setCentralWidget(self.centralwidget)
        self.menubar = QtWidgets.QMenuBar(self)
        self.menubar.setGeometry(QtCore.QRect(0, 0, 2057, 26))
        self.menubar.setObjectName("menubar")
        self.setMenuBar(self.menubar)
        self.statusbar = QtWidgets.QStatusBar(self)
        self.statusbar.setObjectName("statusbar")
        self.setStatusBar(self.statusbar)

        # self.retranslateUi(self)
        _translate = QtCore.QCoreApplication.translate
        
        # self.upload_image_push_button.setText(
        #     _translate(f"{self.filename}", "Upload Image"))

        self.hide_masks_checkbox.setText(
            _translate(f"{self.filename}", "Hide Masks"))
        self.show_instances_contours_checkbox.setText(
            _translate(f"{self.filename}", "Show Instances Contours"))

        self.brush_size_combo_box.setItemText(0, _translate(f"{self.filename}", "1"))
        self.brush_size_combo_box.setItemText(1, _translate(f"{self.filename}", "3"))
        self.brush_size_combo_box.setItemText(2, _translate(f"{self.filename}", "5"))
        self.brush_size_combo_box.setItemText(3, _translate(f"{self.filename}", "7"))
        self.brush_size_combo_box.setItemText(4, _translate(f"{self.filename}", "9"))
        self.brush_size_label.setText(_translate(f"{self.filename}", "Brush Size"))
        self.brush_size_combo_box.setCurrentIndex(1)

        self.opacity_masks_combo_box.setItemText(0, _translate(f"{self.filename}", "0.1"))
        self.opacity_masks_combo_box.setItemText(1, _translate(f"{self.filename}", "0.3"))
        self.opacity_masks_combo_box.setItemText(2, _translate(f"{self.filename}", "0.5"))
        self.opacity_masks_combo_box.setItemText(3, _translate(f"{self.filename}", "0.7"))
        # self.opacity_masks_combo_box.setItemText(4, _translate(f"{self.filename}", "0.9"))
        self.opacity_masks_label.setText(_translate(f"{self.filename}", "Set Opacity of Masks"))
        self.opacity_masks_combo_box.setCurrentIndex(1)
        self.opacity_level = 0.3

        QtCore.QMetaObject.connectSlotsByName(self)

        #connect hide masks checkbox to function
        self.hide_masks_checkbox.stateChanged.connect(self.hide_show_masks)
        #connect show instances contours checkbox to function
        self.show_instances_contours_checkbox.stateChanged.connect(self.show_instances_contours)

        self.right_mouse_clicked_bool = False
        self.graphicsView.show()
        self.show()

    def show_instances_contours(self):
        if self.show_instances_contours_checkbox.isChecked():
            self.show_instances_contours_checkbox_checked_once = True
            self.draw_layer.show_contour_bool = True
            self.draw_layer.showContours()
        elif self.show_instances_contours_checkbox.isChecked() == False and self.show_instances_contours_checkbox_checked_once == True:
            self.draw_layer.show_contour_bool = False
            self.draw_layer.hideContours()

    def hide_show_masks(self):
        if self.hide_masks_checkbox.isChecked():
            self.show_instances_contours_checkbox.setDisabled(True)
            self.hide_masks_checkbox_checked_once = True
            self.draw_layer.hideMasks()
            self.draw_layer.setOpacity(0)
            self.contour_layer.setOpacity(0)
        if self.hide_masks_checkbox.isChecked() == False:
            self.show_instances_contours_checkbox.setDisabled(False)
        if self.hide_masks_checkbox.isChecked() == False and self.hide_masks_checkbox_checked_once == True:
            self.draw_layer.showMasks()
            self.draw_layer.setOpacity(self.opacity_level)
            self.contour_layer.setOpacity(self.opacity_level)

    def setImage(self, img):
        image_name = self.filename.split("/")[-1]
        self.setWindowTitle(f"{image_name}")
        self.image = img
        self.image_height = self.image.shape[0]
        self.image_width = self.image.shape[1]
        self.draw_layer = ImageDraw(np.zeros(
            (self.image_height, self.image_width, 3)), parent=self, num_of_classes=self.num_of_classes)
        self.contour_layer = ContourDraw(
            np.zeros((self.image_height, self.image_width, 3)), parent=self,)
        # self.instance_image = np.zeros((self.image_height, self.image_width))
        self.draw_layer.colors_list = self.colors_list
        self.image_item = pg.ImageItem(img)

        self.image_item.setCompositionMode(QtGui.QPainter.CompositionMode_Plus)

        self.view_box.addItem(self.image_item)
        self.view_box.addItem(self.contour_layer)
        self.view_box.addItem(self.draw_layer)

        self.contour_layer.setOpacity(0.3)
        self.draw_layer.setOpacity(self.opacity_level)
        self.image_item.setOpacity(1)
        self.graphicsView.show()
        self.show()

    def generate_diff_color_palette(self):
        random.seed(random.randint(0, 10000))

        self.colors_list = [(0, 0, 0)]
        for i in range(int(self.num_of_classes) - 1):
            r = random.randint(0, 255)
            g = random.randint(0, 255)
            b = random.randint(0, 255)
            self.colors_list.append((r, g, b))
            if i+1 == self.current_class:
                self.class_buttons_list[i].setStyleSheet(
                    f"background-color: rgb(" + str(r) + "," + str(g) + "," + str(b) + "); border: 5px solid black")
            else:
                self.class_buttons_list[i].setStyleSheet(
                    f"background-color: rgb(" + str(r) + "," + str(g) + "," + str(b) + "); border: 0px solid black")
        for semantic_class in np.unique(self.draw_layer.semantic_image):

            self.draw_layer.image[self.draw_layer.semantic_image ==
                                    semantic_class] = self.colors_list[semantic_class]
        if self.draw_layer.show_contour_bool:
            self.draw_layer.showContours()
        self.current_class_color = self.colors_list[self.current_class]
        self.draw_layer.current_class_color = self.current_class_color
        self.draw_layer.updateImage()

    def reset(self):
        pass

    def clear_all(self):
        # pass
        if self.contour_layer is not None:
            self.view_box.removeItem(self.contour_layer)
        if self.draw_layer is not None:
            self.view_box.removeItem(self.draw_layer)
        if self.image_item is not None:
            self.view_box.removeItem(self.image_item)
    # add a function for key press event
    def keyPressEvent(self, event):
        if event.key() == QtCore.Qt.Key_Control:
            self.draw_layer.is_ctrl_pressed = True
    
    def keyReleaseEvent(self, event):
        if event.key() == QtCore.Qt.Key_Control:
            self.draw_layer.is_ctrl_pressed = False
    def closeEvent(self, event):
        event.accept()
        self.save_label()
        self.on_label_ui_closed()
    # def mouse_moved(self, pos):
        # extract coordinates with respect to the image
        # pos = self.view_box.mapSceneToView(pos)
        # if self.right_mouse_clicked_bool:
        #     kern = np.array([
        #         [0.0, 0.0, 0.5, 0.0, 0.0],
        #         [0.5, 1.0, 1.0, 1.0, 0.5],
        #         [0.8, 1.0, 1.0, 1.0, 0.8],
        #         [0.5, 1.0, 1.0, 1.0, 0.5],
        #         [0.0, 0.0, 0.5, 0.0, 0.0]
        #     ])
        #     kern = kern * 255
            
        #     self.draw_layer.setDrawKernel(
        #         kern, mask=kern, center=(2, 2), mode='add')
            # print('pos: ', pos.x(), pos.y())

    # def right_mouse_clicked(self, event_pos_union):
        # self.last_point = event_pos_union.pos()
        # self.right_mouse_clicked_bool = True

    def change_brush_size(self):
        brush_size = self.brush_size_combo_box.currentText()
        self.brush_size = int(brush_size)
        if self.draw_layer is not None:
            self.draw_layer.setDrawKernel(kernel_size=self.brush_size)
            self.contour_layer.setDrawKernel(kernel_size=self.brush_size)

    def change_opacity_masks(self):
        opacity = self.opacity_masks_combo_box.currentText()
        self.opacity_level = float(opacity)
        if self.draw_layer is not None:
            self.draw_layer.setOpacity(self.opacity_level)

    def click_select_class_push_button(self):
        # get the text(class name) of the push button that was clicked
        push_button = self.centralwidget.sender()
        pushed_button_color = push_button.palette().button().color().getRgb()
        #add a red border to the button that was clicked
        r = pushed_button_color[0]
        g = pushed_button_color[1]
        b = pushed_button_color[2]
        push_button.setStyleSheet(
            f"background-color: rgb(" + str(r) + "," + str(g) + "," + str(b) + "); border: 5px solid black")


        #remove the red border from the other buttons without changing the style sheets 
        for button in self.class_buttons_list:
            if button != push_button:
                button_color = button.palette().button().color().getRgb()
                r = button_color[0]
                g = button_color[1]
                b = button_color[2]
                button.setStyleSheet(
                    f"background-color: rgb(" + str(r) + "," + str(g) + "," + str(b) + "); border: 0px solid black")
        button_text = push_button.text()
        #get index from self.project["class_names"] list which is same as the button text
        class_name = self.project["class_names"].index(button_text)
        self.current_class = int(class_name)

        pushed_button_color = push_button.palette().button().color().getRgb()
        # print(f"push button clicked / text: {class_name}")
        # self.view_box.locate(self.draw_layer)
        # print(pushed_button_color)
        self.current_class_color = pushed_button_color
        self.draw_layer.current_class_color = self.current_class_color
        self.draw_layer.current_class = self.current_class
        self.contour_layer.current_class = self.current_class

    # def retranslateUi(self):
    #     _translate = QtCore.QCoreApplication.translate
    #     self.setWindowTitle(_translate("MainWindow", "MainWindow"))

    #     self.upload_image_push_button.setText(
    #         _translate("MainWindow", "Upload Image"))

    #     self.checkBox.setText(_translate("MainWindow", "Eraser"))
    #     self.brush_size_combo_box.setItemText(0, _translate("MainWindow", "1"))
    #     self.brush_size_combo_box.setItemText(1, _translate("MainWindow", "3"))
    #     self.brush_size_combo_box.setItemText(2, _translate("MainWindow", "5"))
    #     self.brush_size_combo_box.setItemText(3, _translate("MainWindow", "7"))
    #     self.brush_size_combo_box.setItemText(4, _translate("MainWindow", "9"))
    #     self.brush_size_label.setText(_translate("MainWindow", "Brush Size"))


# def main():
#     # app = QtWidgets.QApplication(sys.argv)
#     # num_of_classes = sys.argv[1]
#     num_of_classes = 5

#     MainWindow = QtWidgets.QMainWindow()
#     ui = PanopticSegUI()
#     ui.setupUi(MainWindow, num_of_classes)

#     MainWindow.show()
#     sys.exit(app.exec_())


# if __name__ == '__main__':
#     main()
